
#include "GPL951_body.h"

#include "USB\USBD_Define.h"
#include "USB\USBD.h"

extern int Send_To_USB_DMA_USB(unsigned long USB_RW_Buffer_PTR_A ,unsigned int USBDMA_CHANNEL, unsigned int DMA_Configer);
extern int Receive_From_USB_DMA_USB(unsigned long ,unsigned int);
extern unsigned int CheckUSBRxReady(unsigned int);

///////////////////////////////////////////////////////////////////////////////////////////////////////
//Return Value:
//	1: Fail, 0: Success
///////////////////////////////////////////////////////////////////////////////////////////////////////
int Read_10(unsigned long  lUSB_LUN_Read)
{
	int i;//, j;
	unsigned long SCSI_LBA;
	unsigned int SCSI_Transfer_Length;
	unsigned long USB_RW_Buffer_PTR, USB_RW_Buffer_PTR_A,USB_RW_Buffer_PTR_B,USB_RW_Buffer_PTR_Temp;
	int ret,stage;
	unsigned int USBDMA_CHANNEL0, USBDMA_CHANNEL1, USBDMA_CHANNEL2, USBDMA_CHANNEL3;
	str_USB_Lun_Info*  ptr_USB_LUN_Read;
	
	ptr_USB_LUN_Read = (str_USB_Lun_Info*)lUSB_LUN_Read;
	ulTimeout = 0x4FFFF;
	ret=0x00;
	stage = 0x00;
	Sense_Code = 0;
	R_USB_RW_Busy = 1;
		
	SCSI_LBA=GetLBA();
	
	SCSI_Transfer_Length=GetTransLeng();
	
	USB_RW_Buffer_PTR=GetBufferPointer();
	USB_RW_Buffer_PTR_A=USB_RW_Buffer_PTR;   //add by zhangxh 2006/01/19
	USB_RW_Buffer_PTR_B=USB_RW_Buffer_PTR_A + 256;	

#ifdef OS_vension
	USBDMA_CHANNEL0 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL1 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL2 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL3 = MallocChannel();	 //by zhangxh 2006/01/19
#else
	USBDMA_CHANNEL0 = 0;
	USBDMA_CHANNEL1 = 1;
	USBDMA_CHANNEL2 = 2;
	USBDMA_CHANNEL3 = 3;
#endif

			if ((SCSI_LBA + SCSI_Transfer_Length)>ptr_USB_LUN_Read->ulNandSizeSec)	//check read address overflow
			{
				Sense_Code = 0x1B;
				ret = 1;
				goto End;
			}

			if(ptr_USB_LUN_Read->unLunType == LunType_CDROM)	//CDROM, do not modify below CDROM code
			{
				SCSI_LBA ++;						
				SCSI_LBA = SCSI_LBA << 2;						//1 sector = 4 *512
				SCSI_LBA += ptr_USB_LUN_Read->ulNandStartAddr;		
				SCSI_Transfer_Length = SCSI_Transfer_Length << 2; //length *4
			}
			else
				SCSI_LBA += ptr_USB_LUN_Read->ulNandStartAddr;		

			for(i=0 ; i < SCSI_Transfer_Length ; i++)
			{
				ret = _CDROM_ReadSector((unsigned long)(SCSI_LBA+i), 1, (unsigned long)USB_RW_Buffer_PTR_A);
 		
	 			if (stage)
				{
				Send_To_USB_DMA_USB(USB_RW_Buffer_PTR_A,USBDMA_CHANNEL1, 0x01);
					
					ulTimeout = 0x4FFFF;
					while((*P_USBD_EPEvent & 0x0100) != 0)
					{						
						if (!(ulTimeout--))	
						{
							*P_USBD_EPEvent=0x0600;	
							Sense_Code = 0x12; 
							ret = 1;
							goto End;
						}
					}
					*P_USBD_EPEvent=0x0600;
				}
															
			Send_To_USB_DMA_USB(USB_RW_Buffer_PTR_A, USBDMA_CHANNEL1, 0x00);//DMA Config
			stage=1;
									
			if (i == SCSI_Transfer_Length-1)
			{
				Send_To_USB_DMA_USB(USB_RW_Buffer_PTR_A, USBDMA_CHANNEL1, 0x01);
				ulTimeout = 0x4FFFF;
				while((*P_USBD_EPEvent & 0x0100) != 0)
				{						
					if (!(ulTimeout--))	
					{
						*P_USBD_EPEvent=0x0600;	
						Sense_Code = 0x12; 
						ret = 1;
						goto End;
					}
				}
				*P_USBD_EPEvent=0x0600;
			}
			USB_RW_Buffer_PTR_Temp = USB_RW_Buffer_PTR_B;			
			USB_RW_Buffer_PTR_B = USB_RW_Buffer_PTR_A;
			USB_RW_Buffer_PTR_A = USB_RW_Buffer_PTR_Temp;
		}		
			CSW_Residue=0x00;
End:	
	#ifdef OS_vension
	FreeChannel(USBDMA_CHANNEL0);
	FreeChannel(USBDMA_CHANNEL1);
	FreeChannel(USBDMA_CHANNEL2);
	FreeChannel(USBDMA_CHANNEL3);		
	#endif
	
	return ret;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
//Return Value:
//	1: Fail, 0: Success
///////////////////////////////////////////////////////////////////////////////////////////////////////
int Write_10(unsigned long	lUSB_LUN_Write)
{
	int j;
	unsigned long SCSI_LBA;
	unsigned int SCSI_Transfer_Length;
	unsigned long USB_RW_Buffer_PTR;
	unsigned long USB_RW_Buffer_PTR_A,USB_RW_Buffer_PTR_B,USB_RW_Buffer_PTR_Temp;
	unsigned int USBDMA_CHANNEL0, USBDMA_CHANNEL1, USBDMA_CHANNEL2, USBDMA_CHANNEL3;
	int ret= 0xffff, stage = 0;
	int ret1=0xffff;
	unsigned int Erro_Flag = 0;
	str_USB_Lun_Info*  ptr_USB_LUN_Write;
	
	ptr_USB_LUN_Write = (str_USB_Lun_Info*)lUSB_LUN_Write;
	R_USB_RW_Busy = 1;
	Sense_Code = 0x00;
	SCSI_LBA=GetLBA();
	SCSI_Transfer_Length=GetTransLeng();
	USB_RW_Buffer_PTR=GetBufferPointer();

	USB_RW_Buffer_PTR_A=GetBufferPointer();   //add by zhangxh 2006/01/19
	USB_RW_Buffer_PTR_B=USB_RW_Buffer_PTR_A + 256;
	
#ifdef OS_vension
	USBDMA_CHANNEL0 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL1 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL2 = MallocChannel();	 //by zhangxh 2006/01/19
	USBDMA_CHANNEL3 = MallocChannel();	 //by zhangxh 2006/01/19
#else
	USBDMA_CHANNEL0 = 0;
	USBDMA_CHANNEL1 = 1;
	USBDMA_CHANNEL2 = 2;
	USBDMA_CHANNEL3 = 3;
#endif

		if ((SCSI_LBA + SCSI_Transfer_Length)>ptr_USB_LUN_Write->ulNandSizeSec)	//check address overflow	
		{
			Sense_Code = 0x1B;//LOGICAL BLOCK ADDRESS OUT OF RANGE
			ret = 1;			
			goto End;
		}		
			SCSI_LBA += ptr_USB_LUN_Write->ulNandStartAddr;		
								
		for(j=0; j<(SCSI_Transfer_Length); j++)
		{				
			if (j==0)
			{
				stage = 0;
				ret=Receive_From_USB_DMA_USB(USB_RW_Buffer_PTR_A, USBDMA_CHANNEL1);//Get first sector
				Erro_Flag = CheckUSBRxReady(1);
				*P_USBD_EPEvntClear=0x0010;			
				*P_USBD_EPEvent=0x2000;		// Bulk OUT NACK Reset
				if (Erro_Flag != 0x00)
					break;
			}
			else 
			{		
				stage = 1;			
				Erro_Flag = CheckUSBRxReady(1);
				*P_USBD_EPEvntClear=0x0010;			
				*P_USBD_EPEvent=0x2000;		// Bulk OUT NACK Reset	
				if (Erro_Flag != 0x00)
					break;
						
			}					

			if (j != (SCSI_Transfer_Length-1))
				ret=Receive_From_USB_DMA_USB(USB_RW_Buffer_PTR_B, USBDMA_CHANNEL1);
					
			if (ret1 != 0x00)
				break;

			USB_RW_Buffer_PTR_Temp = USB_RW_Buffer_PTR_B;
			USB_RW_Buffer_PTR_B = USB_RW_Buffer_PTR_A;
			USB_RW_Buffer_PTR_A = USB_RW_Buffer_PTR_Temp;
		}//j
				
		if(ret != 0x00)
		{
			CSW_Residue=SCSI_Transfer_Length-j-1;
			CSW_Residue=CSW_Residue << 9;
			Sense_Code=0x10;	//WRITE FAULT
		}
		else
			CSW_Residue=0;

End:	
	#ifdef OS_vension
	FreeChannel(USBDMA_CHANNEL0);
	FreeChannel(USBDMA_CHANNEL1);
	FreeChannel(USBDMA_CHANNEL2);
	FreeChannel(USBDMA_CHANNEL3);		
	#endif
		
	return ret;	
}


////////////////////////////////////////////////////////////////////////////////////////////
//Purpose:
//			Call back function, if return 0, it will run default process. If return 1, means
//			user modify reply value and default process will be skip.
////////////////////////////////////////////////////////////////////////////////////////////
unsigned int TestUnitReady_CallBack(void)
{
	
	return 0;
}

unsigned int ModeSense6_CallBack(void)
{
	
	return 0;	
}

void VendorCmd_CallBack(void)
{
	
	
	CommandFail(0x1A);	//unsupport command
}
//////////////////////////////////////////////////////////////////////////////////////////////
//This function will be called if PC run to be suspend or device be plug out.
//////////////////////////////////////////////////////////////////////////////////////////////
void USBDSuspend_CallBack(void)
{
//	int n=1;
	R_USB_Suspend=1;	//set R_USB_Suspend=1 will break out usb service loop.

//	*P_MCS3_Ctrl=0x0783;
	
//	*P_Clock_Ctrl=0x4400;	//pll enable, system clock=PLL clock
	
/*
*P_IOD_Data = 0;

*P_IOD_Attrib = 0;

*P_IOD_Dir = 0xE000;
*/
/*	while(1)
	{
		if ((*P_Power_State&0x0F)==0x03)
			break;
	}
*/
/*	*P_WAIT = 0x5005;
	n=1;
	n=2;
	n=3;
	
	
	*P_Clock_Ctrl=0x8400;	//pll enable, system clock=PLL clock
	while(1)
	{
		if ((*P_Power_State&0x0F)==0x02)
			break;
	}
	
	for (n=0; n<400; n++);
	
	*P_MCS3_Ctrl=0x00c4;
*/
}

///////////////////////////////////////////////////////////////////////////////////////////////
//Return 1, if you want to redirect R_Descriptor_High and R_Descriptor_Low address.
//Return 0, use default reply info.
///////////////////////////////////////////////////////////////////////////////////////////////
int EP0_DataPointer_CallBack(int nTableType)
{
	
	
	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////
//Purpose:
//			Setup CDRom timer, user can assigned TimeA~TimeD as timer register.
//			Be careful in IRQ4, will change CDDelay parameter value. If user do not use CDROM
//			function, this function will not be used.
////////////////////////////////////////////////////////////////////////////////////////////
void CDROMTimerStartup(void)
{
	*P_TimerD_Preload=0x10000-4096;	//enable timerD and set timer
    *P_TimerD_Ctrl=0xe064;
}

void CDROMTimerOccur(void)
{
	int nTrigger;
	
	nTrigger = (*P_INT_Status3) & C_INT_TMD_IF;
	if (nTrigger)	
	{		
	    CDROMDelay = 0;	
		*P_TimerD_Ctrl = 0x8064;	//Disable timer
	}
}


	